#!/usr/bin/octave

load(argv(){1}); R1 = R;
load(argv(){2}); R2 = R;

if length(R1) != length(R2)
    fprintf(stderr, 'Wrong number of results.\n');
    exit(1);
end;

for t = 1 : length(R1)
    printf('Test %d ... ', t);
    fflush(stdout);

    for i = 1 : length(R1{t})
        if length(R1{t}{i}) != length(R2{t}{i})
            fprintf(stderr, 'Wrong number of outputs after calling %s.\n', R1{t}{i}{1});
            exit(1);
        end;

        for j = 2 : length(R1{t}{i})
            try
                assert(R1{t}{i}{j}, R2{t}{i}{j});
            catch
                fprintf(stderr, 'Output #%d differs after calling %s.\n', j - 1, R1{t}{i}{1});
                exit(1);
            end_try_catch
        end;
    end;

    disp('passed.');
    fflush(stdout);
end;
