#!/bin/bash

if test $# -ne 1; then
    >&2 echo "Usage: $0 <num_tests>"
    exit 1
fi

liboctave_nanflag_version=/media/stefan/5a8b1eda-69be-4b5d-8c34-2296fb93d6a7/dbg-octave-liboct-patch/run-octave
libinterp_nanflag_version=/media/stefan/5a8b1eda-69be-4b5d-8c34-2296fb93d6a7/dbg-octave-libint-patch/run-octave

input_file=input
liboctave_output_file=liboctave_output
libinterp_output_file=libinterp_output

./generate.m $input_file $1

echo -e "\nRunning liboctave version ..."
$liboctave_nanflag_version --no-gui tests.m $input_file $liboctave_output_file

echo -e "\nRunning libinterp version ..."
$libinterp_nanflag_version --no-gui tests.m $input_file $libinterp_output_file

echo -e "\nChecking results ..."
if ! ./check.m $liboctave_output_file $libinterp_output_file; then
    exit 1
fi

rm -f $input_file $liboctave_output_file $libinterp_output_file
