load(argv(){1})

minmax    = {@min, @max};
cumminmax = {@cummin, @cummax};
nanflags  = {'omitnan', 'includenan'};

for t = 1 : length(T)
    printf('Processing input %d ... ', t);
    fflush(stdout);

    % min/max: one array
    desc = '%s with %d output(s) for one %s along dimension %d with "%s"';

    for i = [1 3] % the former full and spase input respectively
        nd = ifelse(i == 1, ndims(T{t, i}), 2);
        type = typeinfo(T{t, i});

        for j = 1 : length(minmax)
            func = minmax{j};
            for dim = 1 : nd
                for k = 1 : length(nanflags)
                    nanflag = nanflags{k};

                    r = func(T{t, i}, [], dim, nanflag);
                    R{t}{end + 1} = {sprintf(desc, func2str(func), 1, type, dim, nanflag), r};

                    [r ix] = func(T{t, i}, [], dim, nanflag);
                    R{t}{end + 1} = {sprintf(desc, func2str(func), 2, type, dim, nanflag), r, ix};
                end;
            end;
        end;
    end;

    % min/max: two arrays
    desc = '%s for two %s with "%s"';

    for i = [1 3]
        if isscalar(T{t, i}) && !issparse(T{t, i})
            type = typeinfo(T{t, i + 1});
        else
            type = typeinfo(T{t, i});
        end;

        type = strrep(type, 'matrix', 'matrices');
        type = strrep(type, 'scalar', 'scalars');

        for j = 1 : length(minmax)
            func = minmax{j};
            for k = 1 : length(nanflags)
                nanflag = nanflags{k};

                r = func(T{t, i}, T{t, i + 1}, nanflag);
                R{t}{end + 1} = {sprintf(desc, func2str(func), type, nanflag), r};
            end;
        end;
    end;

    % cummin/cummax (one array)
    desc = '%s with %d output(s) for a %s along dimension %d with "%s"';

    for i = [1 3]
        nd = ifelse(i == 1, ndims(T{t, i}), 2);
        type = typeinfo(T{t, i});

        for j = 1 : length(cumminmax)
            func = cumminmax{j};
            for dim = 1 : nd
                for k = 1 : length(nanflags)
                    nanflag = nanflags{k};

                    r = func(T{t, i}, dim, nanflag);
                    R{t}{end + 1} = {sprintf(desc, func2str(func), 1, type, dim, nanflag), r};

                    [r ix] = func(T{t, i}, dim, nanflag);
                    R{t}{end + 1} = {sprintf(desc, func2str(func), 2, type, dim, nanflag), r, ix};
                end;
            end;
        end;
    end;

    disp('done.');
    fflush(stdout);
end;

save(argv(){2}, 'R');
